import { App } from './App';
import { SEO } from './SEO';
export declare const generateLandingPage: (app: App) => LandingPage;
export interface LandingPage extends Website {
    hero: {
        image: string;
    };
}
export interface Hero extends WebpageSection {
    title: string | string[];
    action: string | string[];
}
export interface FAQ {
    question: string;
    answer: string;
    category?: string;
    tag?: string;
    link?: string;
}
export interface LandingPageProps {
    props: LandingPage;
}
export interface Website {
    seo: SEO;
    googleAnalyticsId?: string;
    googleTagManagerId?: string;
    segmentId?: string;
    sentryId?: string;
    intercomId?: string;
    crispId?: string;
}
export interface WebpageSection {
    title: string | string[];
    description?: string;
    header?: string;
    headerBadge?: string;
    headerLink?: string;
    image?: string | string[];
    code?: string;
    codeLanguage?: string;
    action?: string | string[];
}
