export type API = {
  name: string;
};

export type FetcherContext = {
  basePath: string;
  params: any;
};

export const RestAPI =
  <T>(basePath: string) =>
  (params: object): Promise<T> =>
    fetcher({ basePath, params });

export const fetcher = <T>({ basePath, params }: FetcherContext): Promise<T> =>
  fetch(`${basePath}?${new URLSearchParams(params)}`).then((res) => res.json());

//export const transformedFetcher = <T>({basePath, params}: FetcherContext): Promise<T> => fetcher({basePath, params}).then(res => res.data)
